- [HTTP request](https://developers.google.com/pay/value-on-device-fop-v1/google-value-on-device-fop-api/deviceCaptureResultNotification#body.HTTP_TEMPLATE)
- [Request body](https://developers.google.com/pay/value-on-device-fop-v1/google-value-on-device-fop-api/deviceCaptureResultNotification#body.request_body)
  - [JSON representation](https://developers.google.com/pay/value-on-device-fop-v1/google-value-on-device-fop-api/deviceCaptureResultNotification#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://developers.google.com/pay/value-on-device-fop-v1/google-value-on-device-fop-api/deviceCaptureResultNotification#body.response_body)
- [DeviceCaptureResultNotificationResponse](https://developers.google.com/pay/value-on-device-fop-v1/google-value-on-device-fop-api/deviceCaptureResultNotification#DeviceCaptureResultNotificationResponse)
  - [JSON representation](https://developers.google.com/pay/value-on-device-fop-v1/google-value-on-device-fop-api/deviceCaptureResultNotification#DeviceCaptureResultNotificationResponse.SCHEMA_REPRESENTATION)
- [DeviceCaptureResultNotificationResultCode](https://developers.google.com/pay/value-on-device-fop-v1/google-value-on-device-fop-api/deviceCaptureResultNotification#DeviceCaptureResultNotificationResultCode)

Notify Google of the result of a device capture after a `generateDeviceCaptureToken` method call has been made.

The `deviceCaptureResult` value is idempotent for this `generateDeviceCaptureTokenRequestId`, so its value must be identical to any value communicated via `generateDeviceCaptureToken` or `getDeviceCaptureResult`, and cannot be changed by a subsequent call to this method.

If the endpoint encounters an error while processing the request, the endpoint will return HTTP 4xx or 5xx and the HTTP body will either be of type [`ErrorResponse`](https://developers.google.com/pay/value-on-device-fop-v1/payment-integrator-value-on-device-fop-api/ErrorResponse) or contain a generic error (e.g. a message similar to "There was an error. Please try again later.").

The generic error is used in situations where an [`ErrorResponse`](https://developers.google.com/pay/value-on-device-fop-v1/payment-integrator-value-on-device-fop-api/ErrorResponse) with a clear description could be used to help an attacker understand the payment integrator account identifier of other integrators. In these situations, where either the signing key doesn't match, the payment integrator identifier was not found, or the encryption key was unknown, this method will return a generic error. If the request signature could be verified, additional information regarding the error will be returned in an [`ErrorResponse`](https://developers.google.com/pay/value-on-device-fop-v1/payment-integrator-value-on-device-fop-api/ErrorResponse).

An example request looks like:


    {
      "requestHeader": {
        "protocolVersion": {
          "major": 1,
          "minor": 1,
          "revision": 0
        },
        "requestId": "KcgwSKrV76eVNDUbsZ4UA3",
        "requestTimestamp": "1481852928293"
      },
      "paymentIntegratorAccountId": "InvisiCashUSA_USD",
      "generateDeviceCaptureTokenRequestId": "awNaC510cefae3IJdNEvW2",
      "deviceCaptureResult": {
        "deviceCaptureResultCode": "SUCCESS"
      }
    }

An example response looks like:


    {
      "responseHeader": {
        "responseTimestamp": "1481852928324"
      },
      "result": "SUCCESS"
    }

### HTTP request

`POST https://vgw.googleapis.com/gsp/value-on-device-fop-v1/deviceCaptureResultNotification/https://developers.google.com/pay/value-on-device-fop-v1/reference/glossary#payment_integrator_account_id`

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "requestHeader": { object (https://developers.google.com/pay/value-on-device-fop-v1/payment-integrator-value-on-device-fop-api/RequestHeader) }, "paymentIntegratorAccountId": string, "generateDeviceCaptureTokenRequestId": string, "deviceCaptureResult": { object (https://developers.google.com/pay/value-on-device-fop-v1/payment-integrator-value-on-device-fop-api/getDeviceCaptureResult#DeviceCaptureResult) } } ``` |

| Fields ||
|---|---|
| `requestHeader` | `object (https://developers.google.com/pay/value-on-device-fop-v1/payment-integrator-value-on-device-fop-api/RequestHeader)` **REQUIRED**: Common header for all requests. |
| `paymentIntegratorAccountId` | `string` **REQUIRED**: Payment integrator account identifier on which the device capture occurred. |
| `generateDeviceCaptureTokenRequestId` | `string` **REQUIRED** : A unique identifier for this transaction. This is the `requestId` generated by Google during the `generateDeviceCaptureToken` call which this request is associated with. |
| `deviceCaptureResult` | `object (https://developers.google.com/pay/value-on-device-fop-v1/payment-integrator-value-on-device-fop-api/getDeviceCaptureResult#DeviceCaptureResult)` **REQUIRED**: Result of this device capture. |

### Response body

This method supports multiple return types. For additional information about what 4XX or 5XX HTTP status code to return with an `ErrorResponse`, consult the `ErrorResponse` object and [HTTP status codes documentation](https://developers.google.com/pay/value-on-device-fop-v1/guides/connectivity/protocol-standards#http_status_codes).

| Possible response messages ||
|---|---|
| HTTP 200 Status | ``object (`https://developers.google.com/pay/value-on-device-fop-v1/google-value-on-device-fop-api/deviceCaptureResultNotification#DeviceCaptureResultNotificationResponse`)`` |
| HTTP 4XX / 5XX Status | `object (https://developers.google.com/pay/value-on-device-fop-v1/payment-integrator-value-on-device-fop-api/ErrorResponse)` |
| End of mutually exclusive fields. ||

## DeviceCaptureResultNotificationResponse

Response object for the `deviceCaptureResultNotification` method.

| JSON representation |
|---|
| ``` { "responseHeader": { object (https://developers.google.com/pay/value-on-device-fop-v1/payment-integrator-value-on-device-fop-api/ResponseHeader) }, "result": enum (`https://developers.google.com/pay/value-on-device-fop-v1/google-value-on-device-fop-api/deviceCaptureResultNotification#DeviceCaptureResultNotificationResultCode`) } ``` |

| Fields ||
|---|---|
| `responseHeader` | `object (https://developers.google.com/pay/value-on-device-fop-v1/payment-integrator-value-on-device-fop-api/ResponseHeader)` **REQUIRED**: Common header for all responses. |
| `result` | ``enum (`https://developers.google.com/pay/value-on-device-fop-v1/google-value-on-device-fop-api/deviceCaptureResultNotification#DeviceCaptureResultNotificationResultCode`)`` **REQUIRED**: Result of this call. |

## DeviceCaptureResultNotificationResultCode

Result codes for the `deviceCaptureResultNotification` method.

| Enums ||
|---|---|
| `UNKNOWN_RESULT` | Do not ever set this default value! |
| `SUCCESS` | Capture result notification was successful. |